zoukankan      html  css  js  c++  java
  • 2018省赛模拟赛1(2017浙江省赛)

    ZOJ3958 :Cooking Competition

    Time Limit:1000MS    Memory Limit:65536KByte   64 IO Format:%lld & %llu
    Description

    "Miss Kobayashi's Dragon Maid" is a Japanese manga series written and illustrated by Coolkyoushinja. An anime television series produced by Kyoto Animation aired in Japan between January and April 2017.

    In episode 8, two main characters, Kobayashi and Tohru, challenged each other to a cook-off to decide who would make a lunchbox for Kanna's field trip. In order to decide who is the winner, they asked n people to taste their food, and changed their scores according to the feedback given by those people.

    There are only four types of feedback. The types of feedback and the changes of score are given in the following table.

    TypeFeedbackScore Change
    (Kobayashi)
    Score Change
    (Tohru)
    1 Kobayashi cooks better +1 0
    2 Tohru cooks better 0 +1
    3 Both of them are good at cooking +1 +1
    4 Both of them are bad at cooking -1 -1

    Given the types of the feedback of these n people, can you find out the winner of the cooking competition (given that the initial score of Kobayashi and Tohru are both 0)?

    Input

    There are multiple test cases. The first line of input contains an integer T (1 ≤ T ≤ 100), indicating the number of test cases. For each test case:

    The first line contains an integer n (1 ≤ n ≤ 20), its meaning is shown above.

    The next line contains n integers a1a2, ... , an (1 ≤ ai ≤ 4), indicating the types of the feedback given by these n people.

    Output

    For each test case output one line. If Kobayashi gets a higher score, output "Kobayashi" (without the quotes). If Tohru gets a higher score, output "Tohru" (without the quotes). If Kobayashi's score is equal to that of Tohru's, output "Draw" (without the quotes).

    Sample Input

    2
    3
    1 2 1
    2
    3 4
    

    Sample Output

    Kobayashi
    Draw
    

    Hint

    For the first test case, Kobayashi gets 1 + 0 + 1 = 2 points, while Tohru gets 0 + 1 + 0 = 1 point. So the winner is Kobayashi.

    For the second test case, Kobayashi gets 1 - 1 = 0 point, while Tohru gets 1 - 1 = 0 point. So it's a draw.

    Source
    The 14th Zhejiang Provincial Collegiate Programming Contest Sponsored by TuSimple
    每种操作AB都有贡献,但是最后是比大小,所以同加同减不用考虑
    #include<bits/stdc++.h>
    using namespace std;
    typedef long long ll;
    int main()
    {
        int T;
        cin>>T;
        while(T--)
        {
            int n,s1=0,s2=0;
            cin>>n;
            for(int i=0,x;i<n;i++)
            {
                cin>>x;
                if(x==1)s1+=1;
                else if(x==2)s2+=1;
            }
            if(s1>s2)cout<<"Kobayashi
    ";
            else if(s1==s2)cout<<"Draw
    ";
            else cout<<"Tohru
    ";
        }
        return 0;
    }

    ZOJ3959 :Problem Preparation

    Time Limit:1000MS    Memory Limit:65536KByte   64 IO Format:%lld & %llu
    Description

    It's time to prepare the problems for the 14th Zhejiang Provincial Collegiate Programming Contest! Almost all members of Zhejiang University programming contest problem setter team brainstorm and code day and night to catch the deadline, and empty bottles of Marjar Cola litter the floor almost everywhere!

    To make matters worse, one of the team member fell ill just before the deadline. So you, a brilliant student, are found by the team leader Dai to help the team check the problems' arrangement.

    Now you are given the difficulty score of all problems. Dai introduces you the rules of the arrangement:

    1. The number of problems should lie between 10 and 13 (both inclusive).
    2. The difficulty scores of the easiest problems (that is to say, the problems with the smallest difficulty scores) should be equal to 1.
    3. At least two problems should have their difficulty scores equal to 1.
    4. After sorting the problems by their difficulty scores in ascending order, the absolute value of the difference of the difficulty scores between two neighboring problems should be no larger than 2. BUT, if one of the two neighboring problems is the hardest problem, there is no limitation about the difference of the difficulty scores between them. The hardest problem is the problem with the largest difficulty score. It's guaranteed that there is exactly one hardest problem.

    The team members have given you lots of possible arrangements. Please check whether these arrangements obey the rules or not.

    Input

    There are multiple test cases. The first line of the input is an integer T (1 ≤ T ≤ 104), indicating the number of test cases. Then T test cases follow.

    The first line of each test case contains one integer n (1 ≤ n ≤ 100), indicating the number of problems.

    The next line contains n integers s1s2, ... , sn (-1000 ≤ si ≤ 1000), indicating the difficulty score of each problem.

    We kindly remind you that this problem contains large I/O file, so it's recommended to use a faster I/O method. For example, you can use scanf/printf instead of cin/cout in C++.

    Output

    For each test case, output "Yes" (without the quotes) if the arrangement follows the rules, otherwise output "No" (without the quotes).

    Sample Input

    8
    9
    1 2 3 4 5 6 7 8 9
    10
    1 2 3 4 5 6 7 8 9 10
    11
    999 1 1 2 3 4 5 6 7 8 9
    11
    999 1 3 5 7 9 11 13 17 19 21
    10
    15 1 13 17 1 7 9 5 3 11
    13
    1 1 1 1 1 1 1 1 1 1 1 1 2
    10
    2 3 4 5 6 7 8 9 10 11
    10
    15 1 13 3 6 5 4 7 1 14
    

    Sample Output

    No
    No
    Yes
    No
    Yes
    Yes
    No
    No
    

    Hint

    The first arrangement has 9 problems only, which violates the first rule.

    Only one problem in the second and the fourth arrangement has a difficulty score of 1, which violates the third rule.

    The easiest problem in the seventh arrangement is a problem with a difficulty score of 2, which violates the second rule.

    After sorting the problems of the eighth arrangement by their difficulty scores in ascending order, we can get the sequence 1, 1, 3, 4, 5, 6, 7, 13, 14, 15. We can easily discover that |13 - 7| = 6 > 2. As the problem with a difficulty score of 13 is not the hardest problem (the hardest problem in this arrangement is the problem with a difficulty score of 15), it violates the fourth rule.

    Source
    The 14th Zhejiang Provincial Collegiate Programming Contest Sponsored by TuSimple
    有几种规则,首先看题数够不够,是不是有两个签到题难度为1,最后一个不考虑
    #include <bits/stdc++.h>
    using namespace std;
    int main()
    {
        int a[100];
        int t;
        cin>>t;
        while(t--)
        {
            int n;
            cin>>n;
            for(int i=0;i<n;i++)
                cin>>a[i];
            sort(a,a+n);
            int f=1;
            if(a[0]==1&&a[1]==1&&n>=10&&n<=13)
            {
                for(int i=2;i<n-1;i++)
                {
                    if(a[i]-a[i-1]>2)
                    {
                        f=0;
                        break;
                    }
                }
            }
            else
                f=0;
            printf("%s
    ",f?"Yes":"No");
        }
        return 0;
    }

    ZOJ3961 :Let's Chat

    Time Limit:1000MS    Memory Limit:65536KByte   64 IO Format:%lld & %llu
    Description

    ACM (ACMers' Chatting Messenger) is a famous instant messaging software developed by Marjar Technology Company. To attract more users, Edward, the boss of Marjar Company, has recently added a new feature to the software. The new feature can be described as follows:

    If two users, A and B, have been sending messages to each other on the last m consecutive days, the "friendship point" between them will be increased by 1 point.

    More formally, if user A sent messages to user B on each day between the (i - m + 1)-th day and the i-th day (both inclusive), and user B also sent messages to user A on each day between the (i - m + 1)-th day and the i-th day (also both inclusive), the "friendship point" between A and B will be increased by 1 at the end of the i-th day.

    Given the chatting logs of two users A and B during n consecutive days, what's the number of the friendship points between them at the end of the n-th day (given that the initial friendship point between them is 0)?

    Input

    There are multiple test cases. The first line of input contains an integer T (1 ≤ T ≤ 10), indicating the number of test cases. For each test case:

    The first line contains 4 integers n (1 ≤ n ≤ 109), m (1 ≤ m ≤ n), x and y (1 ≤ xy ≤ 100). The meanings of n and m are described above, while x indicates the number of chatting logs about the messages sent by A to B, and y indicates the number of chatting logs about the messages sent by B to A.

    For the following x lines, the i-th line contains 2 integers lai and rai (1 ≤ lai ≤ rai ≤ n), indicating that A sent messages to B on each day between the la,i-th day and the rai-th day (both inclusive).

    For the following y lines, the i-th line contains 2 integers lbi and rbi (1 ≤ lbi ≤ rbi ≤ n), indicating that B sent messages to A on each day between the lb,i-th day and the rbi-th day (both inclusive).

    It is guaranteed that for all 1 ≤ i < xrai + 1 < lai + 1 and for all 1 ≤ i < yrbi + 1 < lbi + 1.

    Output

    For each test case, output one line containing one integer, indicating the number of friendship points between A and B at the end of the n-th day.

    Sample Input

    2
    10 3 3 2
    1 3
    5 8
    10 10
    1 8
    10 10
    5 3 1 1
    1 2
    4 5
    

    Sample Output

    3
    0
    

    Hint

    For the first test case, user A and user B send messages to each other on the 1st, 2nd, 3rd, 5th, 6th, 7th, 8th and 10th day. As m = 3, the friendship points between them will be increased by 1 at the end of the 3rd, 7th and 8th day. So the answer is 3.

    Source
    The 14th Zhejiang Provincial Collegiate Programming Contest Sponsored by TuSimple
    你俩区间重合之后多于m天后,每天算1点贡献,找区间交就行了
    #include<bits/stdc++.h>
    using namespace std;
    typedef long long ll;
    int l[105],r[105];
    int main()
    {
        int T;
        cin>>T;
        while(T--)
        {
            int n,m,x,y,s=0;
            cin>>n>>m>>x>>y;
            m-=2;
            for(int i=0; i<x; i++)cin>>l[i]>>r[i];
            for(int i=0,a,b; i<y; i++)
            {
                cin>>a>>b;
                for(int j=0; j<x; j++)
                {
                    if(r[j]<a)continue;
                    if(l[j]>b)break;
                    if(min(r[j],b)-max(l[j],a)-m>0)
                        s+=min(r[j],b)-max(l[j],a)-m;
                }
            }
            cout<<s<<"
    ";
        }
        return 0;
    }

    ZOJ3960 :What Kind of Friends Are You?

    Time Limit:1000MS    Memory Limit:65536KByte   64 IO Format:%lld & %llu
    Description

    Japari Park is a large zoo home to extant species, endangered species, extinct species, cryptids and some legendary creatures. Due to a mysterious substance known as Sandstar, all the animals have become anthropomorphized into girls known as Friends.

    Kaban is a young girl who finds herself in Japari Park with no memory of who she was or where she came from. Shy yet resourceful, she travels through Japari Park along with Serval to find out her identity while encountering more Friends along the way, and eventually discovers that she is a human.

    However, Kaban soon finds that it's also important to identify other Friends. Her friend, Serval, enlightens Kaban that she can use some questions whose expected answers are either "yes" or "no" to identitfy a kind of Friends.

    To be more specific, there are n Friends need to be identified. Kaban will ask each of them q same questions and collect their answers. For each question, she also gets a full list of animals' names that will give a "yes" answer to that question (and those animals who are not in the list will give a "no" answer to that question), so it's possible to determine the name of a Friends by combining the answers and the lists together.

    But the work is too heavy for Kaban. Can you help her to finish it?

    Input

    There are multiple test cases. The first line of the input is an integer T (1 ≤ T ≤ 100), indicating the number of test cases. Then T test cases follow.

    The first line of each test case contains two integers n (1 ≤ n ≤ 100) and q (1 ≤ q ≤ 21), indicating the number of Friends need to be identified and the number of questions.

    The next line contains an integer c (1 ≤ c ≤ 200) followed by c strings p1p2, ... , pc (1 ≤ |pi| ≤ 20), indicating all known names of Friends.

    For the next q lines, the i-th line contains an integer mi (0 ≤ mi ≤ c) followed by mi strings si, 1si, 2, ... , simi (1 ≤ |sij| ≤ 20), indicating the number of Friends and their names, who will give a "yes" answer to the i-th question. It's guaranteed that all the names appear in the known names of Friends.

    For the following n lines, the i-th line contains q integers ai, 1ai, 2, ... , aiq (0 ≤ aij ≤ 1), indicating the answer (0 means "no", and 1 means "yes") to the j-th question given by the i-th Friends need to be identified.

    It's guaranteed that all the names in the input consist of only uppercase and lowercase English letters.

    Output

    For each test case output n lines. If Kaban can determine the name of the i-th Friends need to be identified, print the name on the i-th line. Otherwise, print "Let's go to the library!!" (without quotes) on the i-th line instead.

    Sample Input

    2
    3 4
    5 Serval Raccoon Fennec Alpaca Moose
    4 Serval Raccoon Alpaca Moose
    1 Serval
    1 Fennec
    1 Serval
    1 1 0 1
    0 0 0 0
    1 0 0 0
    5 5
    11 A B C D E F G H I J K
    3 A B K
    4 A B D E
    5 A B K D E
    10 A B K D E F G H I J
    4 B D E K
    0 0 1 1 1
    1 0 1 0 1
    1 1 1 1 1
    0 0 1 0 1
    1 0 1 1 1
    

    Sample Output

    Serval
    Let's go to the library!!
    Let's go to the library!!
    Let's go to the library!!
    Let's go to the library!!
    B
    Let's go to the library!!
    K
    

    Hint

    The explanation for the first sample test case is given as follows:

    As Serval is the only known animal who gives a "yes" answer to the 1st, 2nd and 4th question, and gives a "no" answer to the 3rd question, we output "Serval" (without quotes) on the first line.

    As no animal is known to give a "no" answer to all the questions, we output "Let's go to the library!!" (without quotes) on the second line.

    Both Alpaca and Moose give a "yes" answer to the 1st question, and a "no" answer to the 2nd, 3rd and 4th question. So we can't determine the name of the third Friends need to be identified, and output "Let's go to the library!!" (without quotes) on the third line.

    Source
    The 14th Zhejiang Provincial Collegiate Programming Contest Sponsored by TuSimple
    模拟找到每一个人的情况
    #include<bits/stdc++.h>
    using namespace std;
    int a[205];
    string s[205],t;
    vector<set<string> >V(205);
    int main()
    {
        ios::sync_with_stdio(false);
        cin.tie(0),cout.tie(0);
        int T;
        cin>>T;
        while(T--)
        {
            int n,q,c;
            cin>>q>>n>>c;
            for(int i=0; i<c; i++)cin>>s[i];
            for(int i=0,k; i<n; i++)
            {
                V[i].clear();
                cin>>k;
                for(int j=0; j<k; j++)
                {
                    cin>>t;
                    V[i].insert(t);
                }
            }
            for(int i=0; i<q; i++)
            {
                for(int j=0; j<n; j++)
                    cin>>a[j];
                int num=-1;
                for(int j=0; j<c; j++)
                {
                    int f=0;
                    for(int k=0; k<n; k++)
                        if(V[k].count(s[j])!=a[k])
                        {
                            f=1;
                            break;
                        }
                    if(!f)
                    {
                        if(num==-1)num=j;
                        else
                        {
                            num=-2;
                            break;
                        }
                    }
                }
                if(num>-1)cout<<s[num]<<"
    ";
                else cout<<"Let's go to the library!!
    ";
            }
        }
        return 0;
    }

    ZOJ3962 :Seven Segment Display

    Time Limit:2000MS    Memory Limit:65536KByte   64 IO Format:%lld & %llu
    Description

    A seven segment display, or seven segment indicator, is a form of electronic display device for displaying decimal numerals that is an alternative to the more complex dot matrix displays. Seven segment displays are widely used in digital clocks, electronic meters, basic calculators, and other electronic devices that display numerical information.

    Edward, a student in Marjar University, is studying the course "Logic and Computer Design Fundamentals" this semester. He bought an eight-digit seven segment display component to make a hexadecimal counter for his course project.

    In order to display a hexadecimal number, the seven segment display component needs to consume some electrical energy. The total energy cost for display a hexadecimal number on the component is the sum of the energy cost for displaying each digit of the number. Edward found the following table on the Internet, which describes the energy cost for display each kind of digit.

    DigitEnergy Cost
    (units/s)
    0 6
    1 2
    2 5
    3 5
    4 4
    5 5
    6 6
    7 3
    DigitEnergy Cost
    (units/s)
    8 7
    9 6
    A 6
    B 5
    C 4
    D 5
    E 5
    F 4

    For example, in order to display the hexadecimal number "5A8BEF67" on the component for one second, 5 + 6 + 7 + 5 + 5 + 4 + 6 + 3 = 41 units of energy will be consumed.

    Edward's hexadecimal counter works as follows:

    • The counter will only work for n seconds. After n seconds the counter will stop displaying.
    • At the beginning of the 1st second, the counter will begin to display a previously configured eight-digit hexadecimal number m.
    • At the end of the i-th second (1 ≤ i < n), the number displayed will be increased by 1. If the number displayed will be larger than the hexadecimal number "FFFFFFFF" after increasing, the counter will set the number to 0 and continue displaying.

    Given n and m, Edward is interested in the total units of energy consumed by the seven segment display component. Can you help him by working out this problem?

    Input

    There are multiple test cases. The first line of input contains an integer T (1 ≤ T ≤ 105), indicating the number of test cases. For each test case:

    The first and only line contains an integer n (1 ≤ n ≤ 109) and a capitalized eight-digit hexadecimal number m (00000000 ≤ m ≤ FFFFFFFF), their meanings are described above.

    We kindly remind you that this problem contains large I/O file, so it's recommended to use a faster I/O method. For example, you can use scanf/printf instead of cin/cout in C++.

    Output

    For each test case output one line, indicating the total units of energy consumed by the eight-digit seven segment display component.

    Sample Input

    3
    5 89ABCDEF
    3 FFFFFFFF
    7 00000000
    

    Sample Output

    208
    124
    327
    

    Hint

    For the first test case, the counter will display 5 hexadecimal numbers (89ABCDEF, 89ABCDF0, 89ABCDF1, 89ABCDF2, 89ABCDF3) in 5 seconds. The total units of energy cost is (7 + 6 + 6 + 5 + 4 + 5 + 5 + 4) + (7 + 6 + 6 + 5 + 4 + 5 + 4 + 6) + (7 + 6 + 6 + 5 + 4 + 5 + 4 + 2) + (7 + 6 + 6 + 5 + 4 + 5 + 4 + 5) + (7 + 6 + 6 + 5 + 4 + 5 + 4 + 5) = 208.

    For the second test case, the counter will display 3 hexadecimal numbers (FFFFFFFF, 00000000, 00000001) in 3 seconds. The total units of energy cost is (4 + 4 + 4 + 4 + 4 + 4 + 4 + 4) + (6 + 6 + 6 + 6 + 6 + 6 + 6 + 6) + (6 + 6 + 6 + 6 + 6 + 6 + 6 + 2) = 124.

    Source
    The 14th Zhejiang Provincial Collegiate Programming Contest Sponsored by TuSimple
    需要想到统计数字个数的方法,先从10进制出发,找位数出现的次数,其他的还是挺简单的
    #include<bits/stdc++.h>
    using namespace std;
    typedef long long ll;
    int has1[17]={6,2,5,5,4,5,6,3,7,6,6,5,4,5,5,4};
    ll a[17],ma=1LL<<32;
    void la(ll n,int ff)
    {
        ll base=1,round=n;
        for(int x=0; x<8; x++)
        {
            int f=round%16;
            round/=16;
            for(int i=0; i<16; i++)
            {
                a[i]=a[i]+ff*(round*base);
                if(f==i)a[i]=a[i]+ff*((n%base)+1);
                else if(f>i)a[i]=a[i]+ff*base;
            }
            base*=16;
        }
    }
    int main()
    {
        int T,n,x,y;
        scanf("%d",&T);
        while(T--)
        {
            memset(a,0,sizeof a);
            scanf("%d%4X%4X",&n,&x,&y);
            ll ans=x*(1LL<<16)+y-1,ans1=0;
            la(ans,-1);
            if(ans+n<ma)
                la(ans+n,1);
            else
                la(ans+n-ma,1),la(ma-1,1);
            for(int i=0;i<16;i++)ans1+=a[i]*has1[i];
            printf("%lld
    ",ans1);
        }
        return 0;
    }

    ZOJ3963 :Heap Partition

    Time Limit:2000MS    Memory Limit:65536KByte   64 IO Format:%lld & %llu
    Description

    A sequence S = {s1s2, ..., sn} is called heapable if there exists a binary tree T with n nodes such that every node is labelled with exactly one element from the sequence S, and for every non-root node si and its parent sjsj ≤ si and j < i hold. Each element in sequence S can be used to label a node in tree T only once.

    Chiaki has a sequence a1a2, ..., an, she would like to decompose it into a minimum number of heapable subsequences.

    Note that a subsequence is a sequence that can be derived from another sequence by deleting some elements without changing the order of the remaining elements.

    Input

    There are multiple test cases. The first line of input contains an integer T, indicating the number of test cases. For each test case:

    The first line contain an integer n (1 ≤ n ≤ 105) — the length of the sequence.

    The second line contains n integers a1a2, ..., an (1 ≤ ai ≤ n).

    It is guaranteed that the sum of all n does not exceed 2 × 106.

    Output

    For each test case, output an integer m denoting the minimum number of heapable subsequences in the first line. For the next m lines, first output an integer Ci, indicating the length of the subsequence. Then output Ci integers Pi1Pi2, ..., PiCi in increasing order on the same line, where Pij means the index of the j-th element of the i-th subsequence in the original sequence.

    Sample Input

    4
    4
    1 2 3 4
    4
    2 4 3 1
    4
    1 1 1 1
    5
    3 2 1 4 1
    

    Sample Output

    1
    4 1 2 3 4
    2
    3 1 2 3
    1 4
    1
    4 1 2 3 4
    3
    2 1 4
    1 2
    2 3 5
    

    Hint

    Source
    The 14th Zhejiang Provincial Collegiate Programming Contest Sponsored by TuSimple
    能理解题意就可以用暴力去模拟,但是要出现很多问题
    但是有一点就是我去贪心,很容易发现其实只会有一个相同的
    #include<bits/stdc++.h>
    using namespace std;
    typedef long long ll;
    const int N=1e5+5;
    int num=0;
    set<int>S;
    set<int>::iterator it;
    vector<int>ans[N];
    int cnt[N],Node[N];
    void solve(int x,int i)
    {
        it=S.upper_bound(x);
        if(it==S.begin())
        {
            S.insert(x);
            cnt[x]=2;
            Node[x]=num;
            ans[num].push_back(i);
            num++;
        }
        else
        {
             it--;
             if(x!=*it)
             {
                 cnt[*it]--;
                 Node[x]=Node[*it];
                 if(cnt[*it]==0)S.erase(*it);
                 S.insert(x);
                 cnt[x]=2;
             }
             else cnt[x]++;
             ans[Node[x]].push_back(i);
        }
    }
    int main()
    {
        ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
        int T;
        cin>>T;
        while(T--)
        {
            S.clear();
            num=0;
            int n;
            cin>>n;
             for(int i=0;i<=n;i++)ans[i].clear(),cnt[i]=0;
            for(int i=1,x; i<=n; i++)cin>>x,solve(x,i);
            cout<<num<<"
    ";
            for(int i=0;i<num;i++)
            {
                cout<<ans[i].size();
                for(int j=0;j<ans[i].size();j++)cout<<" "<<ans[i][j];
                cout<<"
    ";
            }
        }
        return 0;
    }
  • 相关阅读:
    Activity(二)
    channelartlist标签的使用
    把数据保存到数据库附加表 `dede_addonarticle` 时出错,请把相关信息提交给DedeCms官方。Duplicate entry '2' for key 'PRIMARY'
    TP5.0验证器使用方法
    TP5.0登录验证码实现
    dede列表页限制标题长度
    dede搜索页做法
    表单正则验证简便方法
    解决织梦dedecms文档关键字(自动内链)php5.5以上失效的问题 urf-8版本的
    织梦dede解决“更新数据库archives表时出错"方法
  • 原文地址:https://www.cnblogs.com/BobHuang/p/8757370.html
Copyright © 2011-2022 走看看